Index: issm/trunk/src/c/classes/objects/ExternalResults/GenericExternalResult.h
===================================================================
--- issm/trunk/src/c/classes/objects/ExternalResults/GenericExternalResult.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/ExternalResults/GenericExternalResult.h	(revision 13975)
@@ -20,4 +20,5 @@
 #include "../../../io/io.h"
 #include "../../../EnumDefinitions/EnumDefinitions.h"
+#include "../../../classes/IssmComm.h"
 #include "./ExternalResult.h"
 /*}}}*/
@@ -34,5 +35,5 @@
 		int step;
 		IssmDouble time;
-	
+
 	public:
 		/*Diverse: must be in front, as it is used in what follows*/
@@ -99,8 +100,4 @@
 			return -1; 
 		} /*}}}*/
-		int MyRank(void){ /*{{{*/
-			extern int my_rank;
-			return my_rank; 
-		} /*}}}*/
 		int ObjectEnum(void){ /*{{{*/
 			_error_("template ObjectEnum not implemented for this ResultType\n");
@@ -112,10 +109,13 @@
 		/*GenericExternalResult management: */
 void WriteData(FILE* fid,bool io_gather){ /*{{{*/
-			
-	extern  int my_rank;
+
+	int     my_rank;
 	int     type;
 	int     size;
 	IssmPDouble  passiveDouble;
-	
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
 	/*return if now on cpu 0: */
 	if(my_rank)return;
@@ -205,7 +205,10 @@
 template <> inline void GenericExternalResult<char*>::WriteData(FILE* fid,bool io_gather){ /*{{{*/
 
-	extern  int my_rank;
+	int     my_rank;
 	int     type;
 	int     length;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
 
 	/*return if now on cpu 0: */
@@ -235,5 +238,5 @@
 	M=in_M;
 	N=in_N;
-	
+
 	step=in_step;
 	time=in_time;
@@ -254,19 +257,17 @@
 } /*}}}*/
 template <> inline void GenericExternalResult<IssmPDouble*>::Echo(void){ /*{{{*/
-	
+
+	_printLine_("GenericExternalResult<IssmPDouble*>:");
+	this->GenericEcho();
+	_printLine_("   matrix size: " << this->M << "-" << this->N);
+
+} /*}}}*/
+template <> inline void GenericExternalResult<IssmPDouble*>::DeepEcho(void){ /*{{{*/
+
 	int i,j;
 
 	_printLine_("GenericExternalResult<IssmPDouble*>:");
 	this->GenericEcho();
-	_printLine_("   matrix size: " << this->M << "-" << this->N);
-
-} /*}}}*/
-template <> inline void GenericExternalResult<IssmPDouble*>::DeepEcho(void){ /*{{{*/
-	
-	int i,j;
-
-	_printLine_("GenericExternalResult<IssmPDouble*>:");
-	this->GenericEcho();
-	
+
 	_printLine_("   matrix size: " << this->M << "-" << this->N);
 	for (i=0;i<this->M;i++){  
@@ -283,12 +284,14 @@
 } /*}}}*/
 template <> inline void GenericExternalResult<IssmPDouble*>::WriteData(FILE* fid,bool io_gather){ /*{{{*/
-	
-	extern  int my_rank;
+
+	int     my_rank;
 	int     length;
 	int     type;
 	int     rows,cols;
 	char   *name    = NULL;
-	extern  int my_rank;
 	IssmPDouble passiveDouble;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
 
 	if(io_gather){
Index: issm/trunk/src/c/classes/objects/IndependentObject.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/IndependentObject.cpp	(revision 13975)
+++ issm/trunk/src/c/classes/objects/IndependentObject.cpp	(revision 13975)
@@ -0,0 +1,217 @@
+/*!\file IndependentObject.c
+ * \brief: implementation of the IndependentObject object
+ */
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "./objects.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+#include "../../shared/shared.h"
+#include "../../Container/Container.h"
+#include "../../include/include.h"
+#include "../IoModel.h"
+
+/*IndependentObject constructors and destructor*/
+/*FUNCTION IndependentObject::IndependentObject(){{{*/
+IndependentObject::IndependentObject(){
+	this->name=NoneEnum;
+	this->type=0;
+	this->numberofvertices=0;
+}
+/*}}}*/
+/*FUNCTION IndependentObject::IndependentObject(int in_name, int in_type,int in_numberofvertices){{{*/
+IndependentObject::IndependentObject(int in_name, int in_type,int in_numberofvertices){
+
+	this->numberofvertices=0;
+	this->name=in_name;
+	this->type=in_type;
+	if(in_type!=0 && in_type!=1)_error_("cannot create an IndependentObject of type " << in_type);
+	if(this->type==1)this->numberofvertices=in_numberofvertices;
+
+}
+/*}}}*/
+/*FUNCTION IndependentObject::~IndependentObject() {{{*/
+IndependentObject::~IndependentObject(){ //destructor
+}
+/*}}}*/
+
+/*Object virtual functions definitions:*/
+/*FUNCTION IndependentObject::Echo{{{*/
+void IndependentObject::Echo(void){
+
+	_printLine_("IndependentObject:");
+	_printLine_("   name: " << EnumToStringx(this->name));
+	if(this->type==0)
+		_printLine_("   type: scalar");
+	else if(this->type==1)
+		_printLine_("   type: vertex");
+	else
+		_error_(" unknown type: " << this->type);
+	_printLine_("   numberofvertices: " << this->numberofvertices);
+}
+/*}}}*/
+/*FUNCTION IndependentObject::DeepEcho{{{*/
+void IndependentObject::DeepEcho(void){
+	this->Echo();
+}
+/*}}}*/
+/*FUNCTION IndependentObject::Id{{{*/
+int    IndependentObject::Id(void){ return -1; }
+/*}}}*/
+/*FUNCTION IndependentObject::ObjectEnum{{{*/
+int IndependentObject::ObjectEnum(void){
+
+	return IndependentObjectEnum;
+
+}
+/*}}}*/
+/*FUNCTION IndependentObject::copy{{{*/
+Object* IndependentObject::copy(void) { 
+	return new IndependentObject(name,type,numberofvertices);
+} /*}}}*/
+
+/*IndependentObject methods: */
+/*FUNCTION IndependentObject::FetchIndependent{{{*/
+void IndependentObject::FetchIndependent(IoModel* iomodel){
+
+	int my_rank;
+	FILE* fid=NULL;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
+	#ifdef _HAVE_ADOLC_ //cannot come here unless you are running AD mode, from DeclaredIndependents:
+
+	/*Branch according to the type of variable: */
+	if(type==0){ /*scalar: {{{*/
+
+		/*output: */
+		IssmPDouble  pscalar;
+		IssmDouble   scalar; //same as pscalar, except it's an ADOLC independent variable
+		IssmDouble*  scalar_slot=NULL;
+		int      code;
+
+		/*Set file pointer to beginning of the data: */
+		fid=iomodel->SetFilePointerToData(&code,NULL,name);
+
+		if(code!=3)_error_("expecting a IssmDouble for enum " << EnumToStringx(name));
+
+		/*We have to read a scalar from disk. First read the dimensions of the scalar, then the scalar: */
+		if(my_rank==0){
+			if(fread(&pscalar,sizeof(IssmPDouble),1,fid)!=1)_error_("could not read scalar ");
+		}
+
+		/*Now, before we even broadcast this to other nodes, declare the scalar  as an independent variable!: */
+		scalar<<=pscalar;
+
+		#ifdef _HAVE_MPI_
+		MPI_Bcast(&scalar,1,MPI_DOUBLE,0,IssmComm::GetComm()); 
+		#endif
+
+		/*Ok, we are almost done. scalar is now an independent variable. We don't want this variable to be fetched again in the 
+		 *future, which would effectively write over the independency in the ADOLC tape! So we are going to keep track of this 
+		 independent variable inthe iomodel->data[name] data slot. Because this data slot holds double*, we allocate a sizeof(double)
+		 space for it: */
+		scalar_slot=xNew<IssmDouble>(1); *scalar_slot=scalar;
+
+		iomodel->data[name]=scalar_slot;
+		iomodel->independents[name]=true;
+
+	} /*}}}*/
+	else if(type==1){ /* vector: {{{*/
+
+		FILE* fid=NULL;
+		int M,N;
+		IssmPDouble* buffer=NULL; //a buffer to read the data from disk
+		IssmDouble* matrix=NULL; //our independent variable
+		int code=0;
+		int vector_type=0;
+
+		/*Set file pointer to beginning of the data: */
+		fid=iomodel->SetFilePointerToData(&code,&vector_type,name);
+		if((code!=5) && (code!=6) && (code!=7))_error_("expecting a IssmDouble, integer or boolean matrix for enum " << EnumToStringx(name));
+
+		/*We have to read a matrix from disk. First read the dimensions of the matrix, then the whole matrix: */
+		/*numberofelements: */
+		if(my_rank==0){  
+			if(fread(&M,sizeof(int),1,fid)!=1) _error_("could not read number of rows for matrix ");
+		}
+		#ifdef _HAVE_MPI_
+		MPI_Bcast(&M,1,MPI_INT,0,IssmComm::GetComm()); 
+		#endif
+
+		if(my_rank==0){  
+			if(fread(&N,sizeof(int),1,fid)!=1) _error_("could not read number of columns for matrix ");
+		}
+		#ifdef _HAVE_MPI_
+		MPI_Bcast(&N,1,MPI_INT,0,IssmComm::GetComm()); 
+		#endif
+
+		/*Now allocate matrix: */
+		if(M*N){
+			buffer=xNew<IssmPDouble>(M*N);
+			matrix=xNew<IssmDouble>(M*N);
+
+			/*Read matrix on node 0, then broadcast: */
+			if(my_rank==0){  
+				if(fread(buffer,M*N*sizeof(IssmPDouble),1,fid)!=1) _error_("could not read matrix ");
+
+				/*Now, before we even broadcast this to other nodes, declare the whole matrix as a independent variable!: */
+				for (int i=0;i<M*N;++i) matrix[i]<<=buffer[i];  /*we use the <<= ADOLC overloaded operator to declare the independency*/
+			}
+			#ifdef _HAVE_MPI_
+			MPI_Bcast(matrix,M*N,MPI_DOUBLE,0,IssmComm::GetComm()); 
+			#endif
+
+			xDelete<IssmPDouble>(buffer);
+		}
+		else _error_("cannot declare the independent variable " << EnumToStringx(name) <<  "if it's empty!");
+
+		/*Ok, we are almost done. Matrix is now a independent matrix. We don't want this matrix to be fetched again in the 
+		 *future, which would effectively write over the independency in the ADOLC tape! So we are going to keep track of this 
+		 independent matrix inthe iomodel->data[name] data slot: */
+		iomodel->data[name]=matrix;
+		iomodel->independents[name]=true;
+	}/*}}}*/
+	else _error_("should not have a type of " << type);
+
+	#endif
+}
+/*}}}*/
+/*FUNCTION IndependentObject::NumIndependents{{{*/
+int  IndependentObject::NumIndependents(void){
+
+	/*Branch according to the type of variable: */
+	if(type==0){ /*scalar:*/
+		return 1;
+	}
+	else if(type==1){ /* vector:*/
+		return this->numberofvertices;
+	}
+	else _error_("should not have a type of " << type);
+}
+/*}}}*/
+/*FUNCTION IndependentObject::FillIndependents{{{*/
+void IndependentObject::FillIndependents(IssmDouble** data, IssmDouble* xp){
+
+	int i;
+
+	/*Branch according to the type of variable: */
+	if(type==0){ /*scalar:*/
+		xp[0]=*(data[name]);
+	}
+	else if(type==1){ /* vector:*/
+		IssmDouble* values=data[name];
+		for(i=0;i<this->numberofvertices;i++){
+			xp[i]=values[i];
+		}
+	}
+	else _error_("should not have a type of " << type);
+}
+/*}}}*/
Index: issm/trunk/src/c/classes/objects/IndependentObject.h
===================================================================
--- issm/trunk/src/c/classes/objects/IndependentObject.h	(revision 13975)
+++ issm/trunk/src/c/classes/objects/IndependentObject.h	(revision 13975)
@@ -0,0 +1,41 @@
+/*!\file: IndependentObject.h
+ * \brief prototype for IndependentObject.h
+ */ 
+
+#ifndef _INDEPENDENTOBJECT_H_
+#define  _INDEPENDENTOBJECT_H_
+
+/*{{{*/
+#include "./Object.h"
+#include "../../shared/shared.h"
+/*}}}*/
+class IoModel;
+
+class IndependentObject: public Object{
+
+	public:
+
+		int name;
+		int type;  /*0: scalar, 1: vertex*/
+		int numberofvertices;
+
+		/*IndependentObject constructors, destructors {{{*/
+		IndependentObject();
+		IndependentObject(int name, int type, int numberofvertices);
+		~IndependentObject();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{ */
+		void  Echo();
+		void  DeepEcho();
+		int   Id(); 
+		int   ObjectEnum();
+		Object* copy(void);
+		/*}}}*/
+		/*IndependentObject methods: {{{*/
+		void FetchIndependent(IoModel* iomodel);
+		int  NumIndependents(void);
+		void FillIndependents(IssmDouble** data, IssmDouble* xp);
+		/*}}}*/
+
+};
+#endif //ifndef _INDEPENDENTOBJECT_H_
Index: issm/trunk/src/c/classes/objects/Inputs/BoolInput.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/BoolInput.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/BoolInput.cpp	(revision 13975)
@@ -23,6 +23,6 @@
 }
 /*}}}*/
-/*FUNCTION BoolInput::BoolInput(IssmDouble* values){{{*/
-BoolInput::BoolInput(int in_enum_type,IssmBool in_value){
+/*FUNCTION BoolInput::BoolInput(int in_enum_type,bool in_value){{{*/
+BoolInput::BoolInput(int in_enum_type,bool in_value){
 
 	enum_type=in_enum_type;
@@ -53,10 +53,4 @@
 int    BoolInput::Id(void){ return -1; }
 /*}}}*/
-/*FUNCTION BoolInput::MyRank{{{*/
-int    BoolInput::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION BoolInput::ObjectEnum{{{*/
 int BoolInput::ObjectEnum(void){
@@ -68,10 +62,10 @@
 /*FUNCTION BoolInput::copy{{{*/
 Object* BoolInput::copy() {
-	
+
 	return new BoolInput(this->enum_type,this->value);
 
 }
 /*}}}*/
-	
+
 /*BoolInput management*/
 /*FUNCTION BoolInput::InstanceEnum{{{*/
@@ -99,5 +93,5 @@
 /*FUNCTION BoolInput::SpawnResult{{{*/
 ElementResult* BoolInput::SpawnResult(int step, IssmDouble time){
-	
+
 	return new BoolElementResult(this->enum_type,this->value,step,time);
 
Index: issm/trunk/src/c/classes/objects/Inputs/BoolInput.h
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/BoolInput.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/BoolInput.h	(revision 13975)
@@ -2,5 +2,4 @@
  *  \brief: header file for triavertexinput object
  */
-
 
 #ifndef _BOOLINPUT_H_
@@ -18,19 +17,18 @@
 	public:
 		/*just hold 3 values for 3 vertices: */
-		int    enum_type;
-		IssmBool value;
+		int  enum_type;
+		bool value;
 
 		/*BoolInput constructors, destructors: {{{*/
 		BoolInput();
-		BoolInput(int enum_type,IssmBool value);
+		BoolInput(int enum_type,bool value);
 		~BoolInput();
 		/*}}}*/
 		/*Object virtual functions definitions:{{{ */
-		void  Echo();
-		void  DeepEcho();
-		int   Id(); 
-		int   MyRank();
-		int   ObjectEnum();
-		Object* copy();
+		void    Echo();
+		void    DeepEcho();
+		int     Id();
+		int     ObjectEnum();
+		Object *copy();
 		/*}}}*/
 		/*BoolInput management: {{{*/
Index: issm/trunk/src/c/classes/objects/Inputs/ControlInput.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/ControlInput.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/ControlInput.cpp	(revision 13975)
@@ -84,10 +84,4 @@
 int    ControlInput::Id(void){ return -1; }
 /*}}}*/
-/*FUNCTION ControlInput::MyRank{{{*/
-int    ControlInput::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION ControlInput::ObjectEnum{{{*/
 int ControlInput::ObjectEnum(void){
@@ -99,5 +93,5 @@
 /*FUNCTION ControlInput::copy{{{*/
 Object* ControlInput::copy() {
-	
+
 	ControlInput* output=NULL;
 
@@ -106,14 +100,14 @@
 	output->control_id=this->control_id;
 
-	if(values)      output->values=(Input*)this->values->copy();
-	if(savedvalues) output->savedvalues=(Input*)this->savedvalues->copy();
-	if(minvalues)   output->minvalues=(Input*)this->minvalues->copy();
-	if(maxvalues)   output->maxvalues=(Input*)this->maxvalues->copy();
-	if(gradient)    output->gradient=(Input*)this->gradient->copy();
+	if(values)      output->values      = dynamic_cast<Input*>(this->values->copy());
+	if(savedvalues) output->savedvalues = dynamic_cast<Input*>(this->savedvalues->copy());
+	if(minvalues)   output->minvalues   = dynamic_cast<Input*>(this->minvalues->copy());
+	if(maxvalues)   output->maxvalues   = dynamic_cast<Input*>(this->maxvalues->copy());
+	if(gradient)    output->gradient    = dynamic_cast<Input*>(this->gradient->copy());
 
 	return output;
 }
 /*}}}*/
-	
+
 /*ControlInput management*/
 /*FUNCTION ControlInput::InstanceEnum{{{*/
@@ -261,5 +255,5 @@
 
 	if(savedvalues) delete this->savedvalues;
-	this->savedvalues=(Input*)this->values->copy();
+	this->savedvalues=dynamic_cast<Input*>(this->values->copy());
 }/*}}}*/
 /*FUNCTION ControlInput::UpdateValue{{{*/
@@ -269,5 +263,5 @@
 
 	if(values) delete this->values;
-	this->values=(Input*)this->savedvalues->copy();
+	this->values=dynamic_cast<Input*>(this->savedvalues->copy());
 	this->values->AXPY(gradient,scalar);
 }/*}}}*/
Index: issm/trunk/src/c/classes/objects/Inputs/ControlInput.h
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/ControlInput.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/ControlInput.h	(revision 13975)
@@ -2,5 +2,4 @@
  *  \brief: header file for triavertexinput object
  */
-
 
 #ifndef _CONTROLINPUT_H_
@@ -34,5 +33,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
Index: issm/trunk/src/c/classes/objects/Inputs/DatasetInput.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/DatasetInput.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/DatasetInput.cpp	(revision 13975)
@@ -55,10 +55,4 @@
 int    DatasetInput::Id(void){ return -1; }
 /*}}}*/
-/*FUNCTION DatasetInput::MyRank{{{*/
-int    DatasetInput::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION DatasetInput::ObjectEnum{{{*/
 int DatasetInput::ObjectEnum(void){
@@ -70,5 +64,5 @@
 /*FUNCTION DatasetInput::copy{{{*/
 Object* DatasetInput::copy() {
-	
+
 	DatasetInput* output=NULL;
 
@@ -89,5 +83,5 @@
 	outinput=new DatasetInput();
 	outinput->enum_type=this->enum_type;
-	outinput->inputs=(Inputs*)this->inputs->SpawnTriaInputs(indices);
+	outinput->inputs=dynamic_cast<Inputs*>(this->inputs->SpawnTriaInputs(indices));
 
 	/*Assign output*/
@@ -95,5 +89,5 @@
 }
 /*}}}*/
-	
+
 /*DatasetInput management*/
 /*FUNCTION DatasetInput::InstanceEnum{{{*/
@@ -116,6 +110,6 @@
 	/*Get requested input within dataset*/
 	if(index<0 || index > inputs->Size()-1) _error_("index requested (" << index << ") exceeds dataset size (" << inputs->Size() << ")");
-	Input* input=(Input*)this->inputs->GetObjectByOffset(index);
-	
+	Input* input=dynamic_cast<Input*>(this->inputs->GetObjectByOffset(index));
+
 	input->GetInputValue(pvalue,gauss);
 }
Index: issm/trunk/src/c/classes/objects/Inputs/DatasetInput.h
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/DatasetInput.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/DatasetInput.h	(revision 13975)
@@ -2,5 +2,4 @@
  *  \brief: header file for datasetinput object
  */
-
 
 #ifndef _DATASETINPUT_H_
@@ -17,7 +16,6 @@
 
 	public:
-		int    enum_type;
-
-		Inputs*     inputs;
+		int     enum_type;
+		Inputs *inputs;
 
 		/*DatasetInput constructors, destructors: {{{*/
@@ -30,5 +28,4 @@
 		void  DeepEcho();
 		int   Id();
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
Index: issm/trunk/src/c/classes/objects/Inputs/DoubleInput.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/DoubleInput.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/DoubleInput.cpp	(revision 13975)
@@ -53,10 +53,4 @@
 int    DoubleInput::Id(void){ return -1; }
 /*}}}*/
-/*FUNCTION DoubleInput::MyRank{{{*/
-int    DoubleInput::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION DoubleInput::ObjectEnum{{{*/
 int DoubleInput::ObjectEnum(void){
@@ -68,10 +62,10 @@
 /*FUNCTION DoubleInput::copy{{{*/
 Object* DoubleInput::copy() {
-	
+
 	return new DoubleInput(this->enum_type,this->value);
 
 }
 /*}}}*/
-	
+
 /*DoubleInput management*/
 /*FUNCTION DoubleInput::InstanceEnum{{{*/
Index: issm/trunk/src/c/classes/objects/Inputs/DoubleInput.h
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/DoubleInput.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/DoubleInput.h	(revision 13975)
@@ -2,5 +2,4 @@
  *  \brief: header file for triavertexinput object
  */
-
 
 #ifndef _DOUBLEINPUT_H_
@@ -29,5 +28,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
Index: issm/trunk/src/c/classes/objects/Inputs/IntInput.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/IntInput.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/IntInput.cpp	(revision 13975)
@@ -48,10 +48,4 @@
 int    IntInput::Id(void){ return -1; }
 /*}}}*/
-/*FUNCTION IntInput::MyRank{{{*/
-int    IntInput::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION IntInput::ObjectEnum{{{*/
 int IntInput::ObjectEnum(void){
@@ -63,5 +57,5 @@
 /*FUNCTION IntInput::copy{{{*/
 Object* IntInput::copy() {
-	
+
 	return new IntInput(this->enum_type,this->value);
 
@@ -98,5 +92,5 @@
 /*FUNCTION IntInput::SpawnResult{{{*/
 ElementResult* IntInput::SpawnResult(int step, IssmDouble time){
-	
+
 	_error_("not supported yet!");
 
Index: issm/trunk/src/c/classes/objects/Inputs/IntInput.h
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/IntInput.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/IntInput.h	(revision 13975)
@@ -2,5 +2,4 @@
  *  \brief: header file for triavertexinput object
  */
-
 
 #ifndef _INTINPUT_H_
@@ -30,5 +29,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
Index: issm/trunk/src/c/classes/objects/Inputs/PentaP1Input.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/PentaP1Input.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/PentaP1Input.cpp	(revision 13975)
@@ -64,10 +64,4 @@
 int    PentaP1Input::Id(void){ return -1; }
 /*}}}*/
-/*FUNCTION PentaP1Input::MyRank{{{*/
-int    PentaP1Input::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION PentaP1Input::ObjectEnum{{{*/
 int PentaP1Input::ObjectEnum(void){
@@ -77,9 +71,9 @@
 }
 /*}}}*/
-	
+
 /*PentaP1Input management*/
 /*FUNCTION PentaP1Input::copy{{{*/
 Object* PentaP1Input::copy() {
-	
+
 	return new PentaP1Input(this->enum_type,this->values);
 
@@ -363,5 +357,5 @@
 /*FUNCTION PentaP1Input::ConstrainMin{{{*/
 void PentaP1Input::ConstrainMin(IssmDouble minimum){
-	
+
 	int i;
 	const int numnodes=6;
@@ -431,5 +425,5 @@
 /*FUNCTION PentaP1Input::Scale{{{*/
 void PentaP1Input::Scale(IssmDouble scale_factor){
-	
+
 	int i;
 	const int numnodes=6;
@@ -470,5 +464,5 @@
 	int i;
 	const int numnodes=6;
-		
+
 	if(!xIsNan<IssmDouble>(cm_min)) for(i=0;i<numnodes;i++)if (this->values[i]<cm_min)this->values[i]=cm_min;
 	if(!xIsNan<IssmDouble>(cm_max)) for(i=0;i<numnodes;i++)if (this->values[i]>cm_max)this->values[i]=cm_max;
@@ -522,9 +516,7 @@
 
 	/*Intermediaries*/
-	int               i;
-	PentaP1Input *xinputB     = NULL;
-	int               B_numvalues;
-	const int         numnodes    = 6;
-	IssmDouble            AdotBvalues[numnodes];
+	PentaP1Input *xinputB  = NULL;
+	const int     numnodes = 6;
+	IssmDouble    AdotBvalues[numnodes];
 
 	/*Check that inputB is of the same type*/
@@ -533,5 +525,5 @@
 
 	/*Create point wise sum*/
-	for(i=0;i<numnodes;i++){
+	for(int i=0;i<numnodes;i++){
 		_assert_(xinputB->values[i]!=0);
 		AdotBvalues[i]=this->values[i]/xinputB->values[i];
@@ -555,5 +547,4 @@
 	int               i;
 	PentaP1Input *xinputB     = NULL;
-	int               B_numvalues;
 	const int         numnodes    = 6;
 	IssmDouble            minvalues[numnodes];
@@ -586,5 +577,4 @@
 	int               i;
 	PentaP1Input *xinputB     = NULL;
-	int               B_numvalues;
 	const int         numnodes    = 6;
 	IssmDouble            maxvalues[numnodes];
Index: issm/trunk/src/c/classes/objects/Inputs/PentaP1Input.h
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/PentaP1Input.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/PentaP1Input.h	(revision 13975)
@@ -2,5 +2,4 @@
  *  \brief: header file for PentaP1Input object
  */
-
 
 #ifndef _PENTAP1INPUT_H_
@@ -18,5 +17,5 @@
 	public:
 		/*just hold 6 values for 6 vertices: */
-		int    enum_type;
+		int        enum_type;
 		IssmDouble values[6];
 
@@ -27,10 +26,9 @@
 		/*}}}*/
 		/*Object virtual functions definitions:{{{ */
-		void  Echo();
-		void  DeepEcho();
-		int   Id(); 
-		int   MyRank();
-		int   ObjectEnum();
-		Object* copy();
+		void    Echo();
+		void    DeepEcho();
+		int     Id();
+		int     ObjectEnum();
+		Object *copy();
 		/*}}}*/
 		/*PentaP1Input management: {{{*/
Index: issm/trunk/src/c/classes/objects/Inputs/TransientInput.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/TransientInput.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/TransientInput.cpp	(revision 13975)
@@ -79,10 +79,4 @@
 int    TransientInput::Id(void){ return -1; }
 /*}}}*/
-/*FUNCTION TransientInput::MyRank{{{*/
-int    TransientInput::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION TransientInput::ObjectEnum{{{*/
 int TransientInput::ObjectEnum(void){
@@ -109,5 +103,5 @@
 }
 /*}}}*/
-	
+
 /*TransientInput management*/
 /*FUNCTION TransientInput::InstanceEnum{{{*/
@@ -222,5 +216,5 @@
 	/*Retrieve interpolated values for this time step: */
 	Input* input=GetTimeInput(time);
-		   
+
 	/*Call input function*/
 	input->GetInputDerivativeValue(p,xyz_list,gauss);
@@ -237,5 +231,5 @@
 /*FUNCTION TransientInput::GetInputAverage{{{*/
 void TransientInput::GetInputAverage(IssmDouble* pvalue){
-	
+
 	IssmDouble time;
 
@@ -248,5 +242,5 @@
 	/*Call input function*/
 	input->GetInputAverage(pvalue);
-			   
+
 	delete input;
 
@@ -302,8 +296,8 @@
    /*Retrieve interpolated values for this time step: */
 	Input* input=GetTimeInput(time);
-		   
+
 	/*Call input function*/
 	input->SquareMin(psquaremin,process_units,parameters);
-			   
+
 	delete input;
 
@@ -324,5 +318,5 @@
 	/*Call input function*/
 	infnorm=input->InfinityNorm();
-			   
+
 	/*Clean-up and return*/
 	delete input;
@@ -341,8 +335,8 @@
    /*Retrieve interpolated values for this time step: */
 	Input* input=GetTimeInput(time);
-		   
+
 	/*Call input function*/
 	max=input->Max();
-			   
+
 	delete input;
 
@@ -406,5 +400,5 @@
 	/*Call input function*/
 	minabs=input->MinAbs();
-			   
+
 	/*Clean-up and return*/
 	delete input;
@@ -422,8 +416,8 @@
 	/*Retrieve interpolated values for this time step: */
 	Input* input=GetTimeInput(time);
-		   
+
 	/*Call input function*/
 	input->GetVectorFromInputs(vector,doflist);
-			   
+
 	delete input;
 
@@ -432,55 +426,42 @@
 Input* TransientInput::GetTimeInput(IssmDouble intime){
 
-	int     i,j;
-	IssmDouble  deltat;
-	IssmDouble  alpha1,alpha2;
-	bool    found=false;
-	Input*  input=NULL;
-	Input*  input1=NULL;
-	Input*  input2=NULL;
-
-	/*Ok, we have the time, go through the timesteps, and figure out which interval we 
+	IssmDouble deltat;
+	IssmDouble alpha1,alpha2;
+	int        found;
+	int        offset;
+
+	Input *input  = NULL;
+	Input *input1 = NULL;
+	Input *input2 = NULL;
+
+	/*go through the timesteps, and figure out which interval we 
 	 *fall within. Then interpolate the values on this interval: */
-	if(intime<this->timesteps[0]){
+	found=binary_search(&offset,intime,this->timesteps,this->numtimesteps);
+	if(!found) _error_("Input not found (is TransientInput sorted ?)");
+
+	if (offset==-1){
 		/*get values for the first time: */
+		_assert_(intime<this->timesteps[0]);
 		input=(Input*)((Input*)this->inputs->GetObjectByOffset(0))->copy();
-		found=true;
-	}
-	else if(intime>this->timesteps[this->numtimesteps-1]){
+	}
+	else if(offset==(this->numtimesteps-1)){
 		/*get values for the last time: */
-		input=(Input*)((Input*)this->inputs->GetObjectByOffset(numtimesteps-1))->copy();
-		found=true;
+		_assert_(intime>=this->timesteps[offset]);
+		input=(Input*)((Input*)this->inputs->GetObjectByOffset(offset))->copy();
 	}
 	else{
-		/*Find which interval we fall within: */
-		for(i=0;i<this->numtimesteps;i++){
-			if(intime==this->timesteps[i]){
-				/*We are right on one step time: */
-				input=(Input*)((Input*)this->inputs->GetObjectByOffset(i))->copy();
-				found=true;
-				break; //we are done with the time interpolation.
-			}
-			else{
-				if(this->timesteps[i]<intime && intime<this->timesteps[i+1]){
-					/*ok, we have the interval ]i:i+1[. Interpolate linearly for now: */
-					deltat=this->timesteps[i+1]-this->timesteps[i];
-					alpha2=(intime-this->timesteps[i])/deltat;
-					alpha1=(1.0-alpha2);
-
-					input1=(Input*)this->inputs->GetObjectByOffset(i); 
-					input2=(Input*)this->inputs->GetObjectByOffset(i+1);
-
-					input=(Input*)input1->copy();
-					input->Scale(alpha1);
-					input->AXPY(input2,alpha2);
-
-					found=true;
-					break;
-				}
-				else continue; //keep looking on the next interval
-			}
-		}
-	}
-	if(!found)_error_("did not find time interval on which to interpolate forcing values!");
+		/*get values between two times [offset:offset+1[, Interpolate linearly*/
+		_assert_(intime>=this->timesteps[offset] && intime<this->timesteps[offset+1]);
+		deltat=this->timesteps[offset+1]-this->timesteps[offset];
+		alpha2=(intime-this->timesteps[offset])/deltat;
+		alpha1=(1.0-alpha2);
+
+		input1=(Input*)this->inputs->GetObjectByOffset(offset); 
+		input2=(Input*)this->inputs->GetObjectByOffset(offset+1);
+
+		input=(Input*)input1->copy();
+		input->Scale(alpha1);
+		input->AXPY(input2,alpha2);
+	}
 
 	/*Assign output pointer*/
Index: issm/trunk/src/c/classes/objects/Inputs/TransientInput.h
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/TransientInput.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/TransientInput.h	(revision 13975)
@@ -2,5 +2,4 @@
  *  \brief: header file for transientinput object
  */
-
 
 #ifndef _TRANSIENTINPUT_H_
@@ -17,9 +16,9 @@
 
 	public:
-		int     enum_type;
-		int     numtimesteps;
-		Inputs* inputs;
-		IssmDouble* timesteps;
-		Parameters* parameters; //to find current time.
+		int         enum_type;
+		int         numtimesteps;
+		Inputs     *inputs;
+		IssmDouble *timesteps;
+		Parameters *parameters;     //to find current time.
 
 		/*TransientInput constructors, destructors: {{{*/
@@ -33,5 +32,4 @@
 		void  DeepEcho();
 		int   Id();
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
Index: issm/trunk/src/c/classes/objects/Inputs/TriaP1Input.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Inputs/TriaP1Input.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Inputs/TriaP1Input.cpp	(revision 13975)
@@ -64,10 +64,4 @@
 int    TriaP1Input::Id(void){ return -1; }
 /*}}}*/
-/*FUNCTION TriaP1Input::MyRank{{{*/
-int    TriaP1Input::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION TriaP1Input::ObjectEnum{{{*/
 int TriaP1Input::ObjectEnum(void){
@@ -79,10 +73,10 @@
 /*FUNCTION TriaP1Input::copy{{{*/
 Object* TriaP1Input::copy() {
-	
+
 	return new TriaP1Input(this->enum_type,this->values);
 
 }
 /*}}}*/
-	
+
 /*TriaP1Input management*/
 /*FUNCTION TriaP1Input::InstanceEnum{{{*/
@@ -214,5 +208,5 @@
 /*FUNCTION TriaP1Input::ContrainMin{{{*/
 void TriaP1Input::ConstrainMin(IssmDouble minimum){
-	
+
 	int i;
 	const int numnodes=3;
@@ -282,5 +276,5 @@
 /*FUNCTION TriaP1Input::Scale{{{*/
 void TriaP1Input::Scale(IssmDouble scale_factor){
-	
+
 	int i;
 	const int numnodes=3;
@@ -333,5 +327,5 @@
 	int i;
 	const int numnodes=3;
-		
+
 	if(!xIsNan<IssmDouble>(cm_min)) for(i=0;i<numnodes;i++)if (this->values[i]<cm_min)this->values[i]=cm_min;
 	if(!xIsNan<IssmDouble>(cm_max)) for(i=0;i<numnodes;i++)if (this->values[i]>cm_max)this->values[i]=cm_max;
@@ -361,9 +355,8 @@
 
 	/*Intermediaries*/
-	int               i;
-	TriaP1Input *xinputB     = NULL;
-	int               B_numvalues;
-	const int         numnodes    = 3;
-	IssmDouble            minvalues[numnodes];
+	int          i;
+	TriaP1Input *xinputB  = NULL;
+	const int    numnodes = 3;
+	IssmDouble   minvalues[numnodes];
 
 	/*Check that inputB is of the same type*/
@@ -394,5 +387,4 @@
 	int               i;
 	TriaP1Input *xinputB     = NULL;
-	int               B_numvalues;
 	const int         numnodes    = 3;
 	IssmDouble            maxvalues[numnodes];
